<app-loading *ngIf="isLoadingPage"></app-loading>
<form nz-form [formGroup]="form">
  <div nz-row [nzGutter]="[30, 10]">
    <!-- Người phụ thuôc -->
    <div nz-col [nzXs]="24" [nzLg]="24">
      <mb-select [mbDataSelects]="listFamilyRelationship"
                 mbKeyLabel="label"
                 mbKeyValue="value"
                 [mbType]="isSubmitted && form.controls['familyRelationshipId'].errors ? 'error' : 'default'"
                 [mbShowError]="isSubmitted && form.controls['familyRelationshipId'].errors !== null"
                 [mbErrors]="form.controls['familyRelationshipId'].errors"
                 [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.relationTypeName' | translate }}]"
                 mbPlaceholder="{{'staffManager.familyDeductionsInformation.label.attributes.relationTypeName' | translate}}"
                 mbLabelText="{{ 'staffManager.familyDeductionsInformation.label.attributes.relationTypeName' | translate}} <span class='label__required'>*</span>"
                 formControlName="familyRelationshipId"></mb-select>
    </div>

    <!-- Có MST/ GTTT -->
    <div nz-col [nzXs]="24" [nzLg]="24">
      <label nz-checkbox [ngModelOptions]="{standalone: true}" [(ngModel)]="hasPersonalId"
             (ngModelChange)="checkHasPersonalId($event)">{{ 'staffManager.familyDeductionsInformation.label.attributes.hasPersonalId' | translate}}</label>
    </div>

    <!-- Mã số thuế -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="hasPersonalId">
      <mb-input-text formControlName="taxNumber"
                     [mbMaxLength]="20"
                     [mbType]="isSubmitted && form.controls['taxNumber'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['taxNumber'].errors !== null"
                     [mbErrors]="form.controls['taxNumber'].errors"
                     [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '20' }}]"
                     mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.taxNumber' | translate}}"
                     mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.taxNumber' | translate}}"></mb-input-text>
    </div>

    <!-- Số GTTT -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="hasPersonalId">
      <mb-input-text formControlName="personalId"
                     [mbMaxLength]="12" [mnMinLength]="6"
                     [mbType]="isSubmitted && form.controls['personalId'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['personalId'].errors !== null"
                     [mbErrors]="form.controls['personalId'].errors"
                     [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '20' }}]"
                     mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.personalIdNumber' | translate}}"
                     mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.personalIdNumber' | translate}}"></mb-input-text>
    </div>

    <!-- Số GKS -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-input-text formControlName="codeNo"
                     [mbMaxLength]="20"
                     [mbType]="isSubmitted && form.controls['codeNo'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['codeNo'].errors !== null"
                     [mbErrors]="form.controls['codeNo'].errors"
                     [mbErrorDefs]="[
                     { errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.codeNo' | translate }},
                     { errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '20' }}
                     ]"
                     mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.codeNo' | translate}}"
                     mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.codeNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
    </div>

    <!-- Quyển số -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-input-text formControlName="bookNo"
                     [mbMaxLength]="20"
                     [mbType]="isSubmitted && form.controls['bookNo'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['bookNo'].errors !== null"
                     [mbErrors]="form.controls['bookNo'].errors"
                     [mbErrorDefs]="[
                     { errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.bookNo' | translate }},
                     { errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '20' }}
                     ]"
                     mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.bookNo' | translate}}"
                     mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.bookNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
    </div>

    <!-- Quốc gia  -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-select [mbDataSelects]="listNational"
                 mbKeyLabel="label"
                 mbKeyValue="value"
                 [mbType]="isSubmitted && form.controls['nationCode'].errors ? 'error' : 'default'"
                 [mbShowError]="isSubmitted && form.controls['nationCode'].errors !== null"
                 [mbErrors]="form.controls['nationCode'].errors"
                 [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.national' | translate }}]"
                 mbPlaceholder="{{'staffManager.familyDeductionsInformation.label.attributes.national' | translate}}"
                 mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.national' | translate}} <span class='label__required'>*</span>"
                 formControlName="nationCode"></mb-select>
    </div>

    <!-- Tỉnh / Thành phố -->
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-select [mbDataSelects]="provinces"
                 mbPlaceholder="{{'staffManager.label.province' | translate}}"
                 mbLabelText="{{'staffManager.label.province' | translate}} <span class='label__required'>*</span>"
                 formControlName="provinceCode"

                 [mbType]="isSubmitted && form.controls['provinceCode'].errors ? 'error' : 'default'"
                 [mbShowError]="isSubmitted && form.controls['provinceCode'].errors !== null"
                 [mbErrors]="form.controls['provinceCode'].errors"
                 [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.provinceCode' | translate }}]"
      ></mb-select>
    </div>
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-select [mbDataSelects]="districts"
                 mbPlaceholder="{{'staffManager.label.district' | translate}}"
                 mbLabelText="{{'staffManager.label.district' | translate}} <span class='label__required'>*</span>"
                 formControlName="districtCode"

                 [mbType]="isSubmitted && form.controls['districtCode'].errors ? 'error' : 'default'"
                 [mbShowError]="isSubmitted && form.controls['districtCode'].errors !== null"
                 [mbErrors]="form.controls['districtCode'].errors"
                 [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.national' | translate }}]"
      ></mb-select>
    </div>
    <div nz-col [nzXs]="24" [nzLg]="12" *ngIf="!hasPersonalId">
      <mb-select [mbDataSelects]="wards"
                 mbPlaceholder="{{'staffManager.label.ward' | translate}}"
                 mbLabelText="{{'staffManager.label.ward' | translate}} <span class='label__required'>*</span>"
                 formControlName="wardCode"

                 [mbType]="isSubmitted && form.controls['wardCode'].errors ? 'error' : 'default'"
                 [mbShowError]="isSubmitted && form.controls['wardCode'].errors !== null"
                 [mbErrors]="form.controls['wardCode'].errors"
                 [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.wardCode' | translate }}]"
      ></mb-select>
    </div>

    <!-- Giảm trừ từ tháng -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-date-picker
        mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.fromDate' | translate}}"
        mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.fromDate' | translate}} <span class='label__required'>*</span>"
        mbMode="month"
        [mbType]="isSubmitted && (form.errors || form.controls['fromDate'].errors) ? 'error' : 'default'"
        [mbShowError]="isSubmitted && (form.errors || form.controls['fromDate'].errors ) !== null"
        [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['fromDate'].errors"
        [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
        {'fromDate': 'staffManager.familyDeductionsInformation.label.attributes.fromDate' | translate, 'toDate': 'staffManager.familyDeductionsInformation.label.attributes.toDate' | translate}},
             { errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.familyDeductionsInformation.label.attributes.fromDate' | translate }}
        ]"
        formControlName="fromDate"></mb-date-picker>
    </div>

    <!-- Giảm trừ đến tháng -->
    <div nz-col [nzXs]="24" [nzLg]="12">
      <mb-date-picker
        mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.toDate' | translate}}"
        mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.toDate' | translate}}"
        mbMode="month"
        formControlName="toDate"></mb-date-picker>
    </div>

    <!-- Ghi chú -->
    <div nz-col [nzXs]="24" [nzLg]="24">
      <mb-input-text formControlName="note"
                     [mbIsTextAre]="true"
                     [mbMaxLength]="500"
                     [mbConfig]="{ rows: 3, autoSize: true }"
                     [mbType]="isSubmitted && form.controls['note'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['note'].errors !== null"
                     [mbErrors]="form.controls['note'].errors"
                     [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': '500' }}]"
                     mbPlaceholderText="{{'staffManager.familyDeductionsInformation.label.attributes.note' | translate}}"
                     mbLabelText="{{'staffManager.familyDeductionsInformation.label.attributes.note' | translate}}"></mb-input-text>
    </div>
  </div>
</form>
